         PRINT NOGEN
         BEGIN NAME=QXTI,AMODE=64
***********************************************************************
*       Licensed Materials - Property of IBM                          *
*       "Restricted Materials of IBM"                                 *
*       5748-T15                                                      * 
*       Copyright IBM Corp. 2003, 2006                                *
*       All Rights Reserved                                           *
*       US Government Users Restricted Rights - Use, duplication      *
*       or dislosure restricted by GSA ADP Schedule Contract          *
*       with IBM Corp.                                                *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
 TITLE 'QXTI - GENERAL TAPE DRIVER'
***********************************************************************
*
* MODULE NAME..... QXTI
* DESCRIPTION..... GENERAL TAPE DRIVER
* RELATED MODULE.. QXTG (ENTNC FROM CVZZ)
*                  QTP2
*                  QXTH
*                  QXTJ
*                  QTP5
*                  QTP6
*                  QTP7
*                  QTP8
* DOCUMENT NAME... GENERAL TAPE DRIVER USERS GUIDE
* LEVEL........... N/A
*
* FUNCTION...      THIS SEGMENT PERFORMS THE FOLLOWING SYSTEM TEST
*                  COMMANDS:
*                   - SETUP
*
* MODULE ATTRIBUTES..
*   TYPE.......... 'E' (ECB CONTROLLED)
*   DEPENDENCY.... NONE (OBJECT SHIPPABLE)
*   ALLOCATION.... 4K FILE RESIDENT
*   ENVIRONMENT... BASE, BSS
*   ENTRY POINT... QXTI  (ENTNC FROM QXTH)
*
* ECB-CONVENTIONS.......
*
*   WORK AREAS
*         EBX000-103    SEE EQUATE MACRO TA0EQ
*
* DATA LEVELS
*         D1 - WORK BLOCK (INPUT OR OUTPUT)
*         D2 - SCRATCH - USED TO READ CORE LEVELS
*
* REGISTER-CONVENTIONS..
*         R0 - UATBC PROCESSING USAGE
*         R1 - BASE REGISTER FOR TAPE LIST TABLE
*         R2 - POINTER TO WTOPC MESSAGE
*         R3 - SCRATCH
*         R4 - SCRATCH
*         R5 - SCRATCH
*         R6 - MI0MI INPUT MESSAGE BASE
*         R7 - BAS REG
*         R14 - WORK REG
*             - USED BY WTOPC
*         R15 - WORK REG
*             - USED BY WTOPC
*
***********************************************************************
** CHANGE ACTIVITY...
**
**        UPDATE BY          PLOG #   DATE   DESCRIPTION
**        ---------          -------  ------ ------------
**        KENT               TD00301  071390 MSG SETTING ENHANCEMENTS
**        KENT               TD00346  022891 TEP PROJECT IMPROVEMENTS
**        KENT               TD00362  060591 REMOVE SETUP RESTRICTIONS
**        KENT               TD00368  070391 ADD SCK TAPE
**        KENT               TD00383  101191 ADD FAC TAPE
**        KENT               TD00402  031092 ADD TUT/FIX DBR TAPE
**        MKENT              TD00425  030293 UPDATE OLD TAPE  @TD00425
**        MKENT              TD00427  050693 REMOVE 3420 INFO @TD00427
**        MKENT              TD00432  061493 ADD BFA TAPE
**        MKENT              NONE     062993 FORCE MESSAGES TO RO ONLY
**        MKENT              TD00452  102993 ADD LOG,LRS TAPES
**        MKENT              TD00453  102993 REMOVE JCD/ADD RTC TAPE
**        MKENT              VS00492  102993 SET TLD TAPE TO NOGEN
**        STRMBRGR           TD00464  110193 ADD JOB FOR TPFDF
**        JTARBY             TD00621  030295 RTA TIMEOUT VALUE OF T010
**        STRMBRGR           TD00625  032295 SET JOB/BFA TO NOGEN
**        YMLI               F14612   081506 The output routing
***********************************************************************
           EJECT
*---------------------------------------------------------------------*
* DSECTS
*---------------------------------------------------------------------*
TAPETBL  DSECT
TBLNAME  DS    C'XXX'                  TAPE NAME
TAPATTR  DS    X                       INDICATOR FLAGS
BSSONLY  EQU   X'80'                   TAPE IS BSS ONLY
IOINPUT  EQU   X'40'                   TAPE IS INPUT ONLY
IOOUTPUT EQU   X'20'                   TAPE IS OUTPUT ONLY
IOBOTH   EQU   IOINPUT+IOOUTPUT        TAPE IS BOTH INPUT/OUTPUT
*
LNL      EQU   X'10'                   NONLABELED TAPE
LSU      EQU   X'08'                   STANDARD USER LABELED TAPE
BLKMODE  EQU   X'04'                   TAPE IS BLOCKED MODE
NOGEN    EQU   X'02'                   GENERATION NUMBERS NOT USED
*        EQU   X'01'                   RESERVED
TBLPARMS DS    A(0)                    OPTIONAL PARAMETER LIST POINTER
LTAPETBL EQU   *-TAPETBL
$IS$     CSECT
*
*---------------------------------------------------------------------*
* INSERT DATE AND TIME OF MOST CURRENT ASSEMBLY FOR DEBUGGING PURPOSES
*---------------------------------------------------------------------*
         J     QXTI0000                                                 64MODE
         DC    CL8'&SYSDATE'
         DC    CL1' '
         DC    CL8'&SYSTIME'
*
         SPACE 1
         MI0MI REG=R6                  INPUT MESSAGE DSECT
         USING TAPETBL,R1
QXTI0000 DS    0H
         LEVTA LEVEL=0,NOTUSED=QXTISETUP
         SPACE 5
*---------------------------------------------------------------------*
*
*  IF LEVEL 0 NOT IN USE, SETUP COMMAND ASSUMED TO BE IN PROGRESS
*
*  OTHERWISE, A USER ISSUED COMMAND IS BEING PROCESSED
*
*---------------------------------------------------------------------*
         SPACE 5
*---------------------------------------------------------------------*
*
*  VERIFY WE'RE NOT ABOVE 1052 STATE  (ZTLMR RESTRICTION)
*
*---------------------------------------------------------------------*
         CZ3CP                         GET STATE INDICATOR EQUATES
         CINFC R,CMMSTI,F              LOOK AT STATE INDICATOR
         TM    0(R14),X'F0'-CC1052     IS STATE ABOVE 1052?
         JNZ   QXTIERR3                NO, SIGNAL AN ERROR              64MODE
         SPACE 5
         PUSH  USING
*---------------------------------------------------------------------*
*
*  MAKE SURE NO TAPES ARE MOUNTED.  OTHERWISE A DUMP WILL OCCUR
*  WHEN THE USER ATTEMPTS TO DISMOUNT THE TAPE.
*
*  IF THE FIRST ENTRY IN THE TAPE STATUS TABLE HAS AN SDA OF
*  0, THEN THERE ARE NO TAPES MOUNTED.  WE CAN CONTINUE WITH
*  THE SETUP PROCESS IN THAT CASE.
*
*---------------------------------------------------------------------*
         CINFC R,CMMTS1                RETURN ADDR OF TSTB IN R14
         LGR   R4,R14                  COPY INTO R4                     64MODE
         ITSTB SEC=1,REG=R4            ADDRESS TSTB SECTION 1
*
         CONKC D,@02ANT,R3             GET MAX NUMBER OF TAPES
         BCTGR R3,R0                   ADJUST COUNT BY 1                64MODE
*
QXTI0100 DS    0H
         LA    R4,CPMT1S(R4)           BUMP TO NEXT ENTRY
         CLC   CPMTDV,ZERO             TAPE CONFIGURED?
         JE    QXTI0150                NO, JUST ITERATE                 64MODE
         CLC   CPMTNM,=AL3(CP0FRE)     TAPE NAME SLOT AVAILABLE?
         JE    QXTI0150                YES, JUST ITERATE                64MODE
*---------------------------------------------------------------------*
*  CHECK TO SEE IF TAPE IS MOUNTED TO THIS SS/SSU
*---------------------------------------------------------------------*
         UATBC IDLOC=(E,SSU,R5),NAME=R0 RETURN SS NAME IN R0
         MS0UT REG=R5
         CGF   R0,CPMSSN               TAPE ASSIGNED TO THIS SUBSYS?    64MODE
         JNE   QXTI0150                NO, ITERATE                      64MODE
*---------------------------------------------------------------------*
*  SPECIAL CASE FOR REALTIME TAPES (SINCE SSU = SSN)
*---------------------------------------------------------------------*
         CLC   =C'RT',CPMTNM           REALTIME TAPE?
         JNE   QXTI0125                NO, TEST SSU DATA NORMALLY       64MODE
         CGF   R0,CPMSSU               ASSIGNED TO THIS SSU?            64MODE
         JE    QXTIERR5                YES, SIGNAL AN ERROR             64MODE
         J     QXTI0150                OTHERWISE ITERATE                64MODE
QXTI0125 DS    0H
         CLC   CPMSSU,MU0NAM           ASSIGNED TO THIS SSU?
         JNE   QXTI0150                NO, ITERATE                      64MODE
*---------------------------------------------------------------------*
*  OTHERWISE - PASSED ALL TESTS AND A TAPE IS MOUNTED FOR THIS SS/SSU
*---------------------------------------------------------------------*
         J     QXTIERR5                SIGNAL AN ERROR                  64MODE
QXTI0150 DS    0H
         BRCTG R3,QXTI0100                                              64MODE
         SPACE 5
*---------------------------------------------------------------------*
*
*  MAKE SURE THAT SETUP ISN'T ALREADY RUNNING BY CHECKING THE GLOBAL
*  FIELD.
*
*---------------------------------------------------------------------*
         GLOBZ REGR=R3                 GET ACCESS TO GLOBALS
         LGF   R3,@ISSDRV              LOAD OUR PIECE OF THEM           64MODE
         LTGR  R3,R3                   GLOBAL AREA AVAILABLE?           64MODE
         JZ    QXTI0160                NO, BYPASS SETTINGS              64MODE
         SD0RV REG=R3                  R3 = BASE FOR TAPE GLOBALS
         TM    @TD1STAT,@TD1SETU       SETUP ALREADY RUNNING?
         JNZ   QXTIERR4                YES, SIGNAL AN ERROR             64MODE
         OI    @TD1STAT,@TD1SETU       SHOW SETUP ALREADY RUNNING
*
*                                      START PROCESSING
QXTI0160 DS    0H
         MVI   QXT4STP,STEPDEAC        INITIALIZE STEP VALUE
         POP   USING
         EJECT 1
QXTISETUP DS    0H
         CINFC R,CMMXCR                GET PRIME CRAS ADDRESS
         MVC   EBROUT,0(R14)           RESTORE EBROUT
         MVI   MSGDEF,MSGIMSG          FORCE 'I' TYPE MESSAGES
*
         CLI   QXT4STP,STEPDEAC        TLMR DEACTIVATE STEP?
         JE    SETUPTLMR                                                64MODE
*
         CLI   QXT4STP,STEPINIT        TLMR INITIALIZE STEP?
         JE    SETUPTLMR                                                64MODE
*
         CLI   QXT4STP,STEPDONE        ALL DONE?
         JE    SETUPDONE                                                64MODE
*
         CLI   QXT4STP,STEPDELT        DELETE TAPE LABELS?
         JE    SETUPTLBL                                                64MODE
*
         CLI   QXT4STP,STEPADDT        ADD/DEFINE TAPE LABELS?
         JE    SETUPTLBL                                                64MODE
*
         CLI   QXT4STP,STEPUSET        ACTIVATE TAPE LABELS?
         JE    SETUPTLBL                                                64MODE
*
         J     QXTIERR1                UNKNOWN VALUE -- EXIT            64MODE
         EJECT 1
SETUPTLMR DS  0H
*
         SGR   R3,R3                                                    64MODE
         IC    R3,QXT4STP              SHOW CURRENT STEP IN MSG
         LA    R2,QXTIM89              SEND MSG
         BRAS  R7,QXTIWTP1             SEND INFORMATIVE MSG TO USER     64MODE
*
         LA    R3,TLMR_DLAY            SHOW CRETC DELAY TIME
         LA    R2,QXTIM90              SEND MSG
         BRAS  R7,QXTIWTP1             SEND INFORMATIVE MSG TO USER     64MODE
*
         BRAS  R7,QXTIGETM             GET AND INITIALIZE MSG BLOCK     64MODE
*
         MVC   MI0ACC(L'MZTLMR),MZTLMR MOVE IN ZTLMR COMMAND TEXT
         LA    R15,L'MZTLMR            CALCULATE INITIAL MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         SPACE 1
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
         CLI   QXT4STP,STEPDEAC        DEACTIVATE STEP?
         JNE   TLMR_100                NO, ASSUME INITIALIZE STEP       64MODE
*
         MVC   0(L'MDEACREC,R14),MDEACREC   MOVE IN TLMR COMMAND
         LA    R15,L'MDEACREC(R15)     CALCULATE NEW MSG LENGTH
         MVI   QXT4STP,STEPINIT        INDICATE NEXT STEP
         J     TLMR_200                SEND OUT THE MESSAGE             64MODE
TLMR_100 DS    0H
*
         MVC   0(L'MINITIAL,R14),MINITIAL   MOVE IN TLMR COMMAND
         LA    R15,L'MINITIAL(R15)     CALCULATE NEW MSG LENGTH
         MVI   QXT4STP,STEPDELT        INDICATE NEXT STEP
         SPACE 1
TLMR_200 DS    0H
         STH   R15,MI0CCT              AND UPDATE
         BRAS  R7,QXTISNDM             FINISH THE MSG AND SEND IT       64MODE
         SPACE 2
         LA    R14,TLMR_DLAY           LOAD CRETC DELAY
         CRETC S,QXTI,STATE=1052,PARM=QXT4ACTW
*                                      SET ALARM CLOCK TO WAKE BACK UP
         J     QXTIEXIT                DONE - QUIT UNTIL LATER          64MODE
         EJECT 1
SETUPTLBL DS  0H
*
         SGR   R3,R3                                                    64MODE
         IC    R3,QXT4STP              SHOW CURRENT STEP IN MSG
         LA    R2,QXTIM89              SEND MSG
         BRAS  R7,QXTIWTP1             SEND INFORMATIVE MSG TO USER     64MODE
*
         LA    R3,TLBL_DLAY            SHOW CRETC DELAY TIME
         LA    R2,QXTIM90              SEND MSG
         BRAS  R7,QXTIWTP1             SEND INFORMATIVE MSG TO USER     64MODE
         LA    R1,TAPELIST             BASE OF TAPE LABEL LIST
TLBL_LOOP DS    0H
*
         CLC   TBLNAME,=C'XXX'         END OF THE LIST?
         JE    TLBL_DONE               YES, LEAVE THE LOOP              64MODE
         CLC   CE1SSU,SSUBSS           RUNNING IN THE BSS?
         JE    TLBL_010                YES, SKIP CHECKS                 64MODE
         TM    TAPATTR,BSSONLY         BSS ONLY?
         JO    TLBL_NEXT               YES, SKIP TO NEXT ENTRY          64MODE
*
TLBL_010 DS  0H
         BRAS  R7,QXTIGETM             GET AND INITIALIZE MSG BLOCK     64MODE
*
         MVC   MI0ACC(L'MZTLBL),MZTLBL MOVE IN ZTLBL COMMAND TEXT
         LA    R15,L'MZTLBL            CALCULATE INITIAL MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         SPACE 1
*
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
         MVC   0(L'TBLNAME,R14),TBLNAME     MOVE IN TAPE NAME
         LA    R15,L'TBLNAME(R15)      CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         SPACE 1
*
         CLI   QXT4STP,STEPDELT        DELETE TAPE LABEL?
         JE    TLBL_DELT                                                64MODE
*
         CLI   QXT4STP,STEPADDT        ADD TAPE LABEL?
         JE    TLBL_ADDT                                                64MODE
*
         CLI   QXT4STP,STEPUSET        USE TAPE LABEL?
         JE    TLBL_USET                                                64MODE
*
         J     QXTIERR1                UNKNOWN VALUE -- EXIT            64MODE
         EJECT 1
**
*  ISSUE COMMAND TO DELETE OLD LABELS
**
TLBL_DELT DS  0H
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
         MVC   0(L'MDELTAP,R14),MDELTAP     MOVE TEXT TO OUTPUT BLOCK
         LA    R15,L'MDELTAP(R15)      CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              UPDATE LENGTH
         SPACE 1
         BRAS  R7,QXTISNDM             SEND OUT THE MESSAGE             64MODE
         SPACE 2
         MVI   QXT4NXT,STEPADDT        INDICATE NEXT STEP
         J     TLBL_NEXT               ITERATE FOR NEXT TABLE ENTRY     64MODE
         EJECT 1
**
*  ISSUE COMMAND TO ADD NEW LABEL
**
TLBL_ADDT DS  0H
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
         MVC   0(L'MADDTAP,R14),MADDTAP     MOVE TEXT TO OUTPUT BLOCK
         LA    R15,L'MADDTAP(R15)      CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              UPDATE LENGTH
         SPACE 1
*
TLBL_IO  DS    0H
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
*
         TM    TAPATTR,IOBOTH          BOTH INPUT AND OUTPUT?
         JO    TLBL_IOBOTH             YES, SET IT                      64MODE
         JZ    TLBL_BLK                NEITHER, CHECK ON NEXT VALUE     64MODE
*
         TM    TAPATTR,IOINPUT         INPUT MODE?
         JO    TLBL_IOIN               YES, SET IT                      64MODE
         J     TLBL_IOOUT              OTHERWISE, MUST BE OUTPUT        64MODE
TLBL_IOIN DS   0H
         MVC   0(L'MINPUT,R14),MINPUT  MOVE IN PARAMETER
         LA    R15,L'MINPUT(R15)       CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         J     TLBL_BLK                DONE, CHECK ON NEXT VALUE        64MODE
         SPACE 1
TLBL_IOOUT DS  0H
         MVC   0(L'MOUTPUT,R14),MOUTPUT     MOVE IN PARAMETER
         LA    R15,L'MOUTPUT(R15)      CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         J     TLBL_BLK                DONE, CHECK ON NEXT VALUE        64MODE
         SPACE 1
TLBL_IOBOTH DS 0H
         MVC   0(L'MIOBOTH,R14),MIOBOTH     MOVE IN PARAMETER
         LA    R15,L'MIOBOTH(R15)      CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         SPACE 5
TLBL_BLK DS    0H
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
*
         TM    TAPATTR,BLKMODE         BLOCK MODE?
         JZ    TLBL_LBL                NO, CHECK ON NEXT VALUE          64MODE
*
         MVC   0(L'MBLOCK,R14),MBLOCK  MOVE IN PARAMETER
         LA    R15,L'MBLOCK(R15)       CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         SPACE 5
TLBL_LBL DS    0H
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
*
         TM    TAPATTR,LNL+LSU         BOTH INDICATORS SET?
         JO    QXTIERR2                YES, SIGNAL ERROR                64MODE
         JZ    TLBL_GEN                NEITHER SET - CHECK NEXT VALUE   64MODE
*
         TM    TAPATTR,LNL             NON-LABELED TAPE?
         JO    TLBL_LNL                YES, SET 'LNL' VALUE             64MODE
         J     TLBL_LSU                OTHERWISE, SET 'LSU' PARAMETER   64MODE
*
TLBL_LSU DS    0H
         MVC   0(L'MLSU,R14),MLSU      MOVE IN PARAMETER
         LA    R15,L'MLSU(R15)         CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         J     TLBL_GEN                DONE - CHECK ON NEXT VALUE       64MODE
*
TLBL_LNL DS    0H
         MVC   0(L'MLNL,R14),MLNL      MOVE IN PARAMETER
         LA    R15,L'MLNL(R15)         CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
         SPACE 5
TLBL_GEN DS    0H                                             @TD00425
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH @TD00425  64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
*                                                             @TD00425
         TM    TAPATTR,NOGEN           OMIT GENERATION NUMBERS?
         JZ    TLBL_XXX                NO, CHECK ON NEXT VALUE@TD00425  64MODE
*                                                             @TD00425
         MVC   0(L'MNOGEN,R14),MNOGEN  MOVE IN PARAMETER      @TD00425
         LA    R15,L'MNOGEN(R15)       CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE             @TD00425
         SPACE 5                                              @TD00425
TLBL_XXX DS    0H                                             @TD00425
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
*
         LLGF  R3,TBLPARMS                                              64MODE
         LTGR   R3,R3                  ANY ADDITIONAL PARAMETERS?       64MODE
         JZ    TLBL_020                                                 64MODE
*
         LA    R3,QXTI0000(R3)         CALCULATE ADDRESS TO MOVE FROM
         MVC   0(LPARM,R14),0(R3)      MOVE IN PARAMETER
         LA    R15,LPARM(R15)          CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              AND UPDATE
*
TLBL_020 DS    0H
         SPACE 1
         BRAS  R7,QXTISNDM             SEND OUT THE MESSAGE             64MODE
         SPACE 2
         MVI   QXT4NXT,STEPUSET        INDICATE NEXT STEP
         J     TLBL_NEXT                                                64MODE
         EJECT 1
**
*  ISSUE COMMAND TO ACTIVATE NEW LABEL
**
TLBL_USET DS   0H                      DELETE ALL TAPES IN THE LIST
         LGH   R15,MI0CCT              GET CURRENT MSG LENGTH           64MODE
         LA    R14,MI0ACC(R15)         CALCULATE ADDRESS TO STORE TO
         MVC   0(L'MUSETAP,R14),MUSETAP     MOVE TEXT TO OUTPUT BLOCK
         LA    R15,L'MUSETAP(R15)      CALCULATE NEW MSG LENGTH
         STH   R15,MI0CCT              UPDATE LENGTH
         BRAS  R7,QXTISNDM             SEND OUT THE MESSAGE             64MODE
         SPACE 2
         MVI   QXT4NXT,STEPDONE        INDICATE NEXT STEP
         J     TLBL_NEXT                                                64MODE
         SPACE 5
TLBL_NEXT DS   0H
         LA    R1,LTAPETBL(R1)         BUMP TO NEXT TABLE ENTRY
         J     TLBL_LOOP               ITERATE FOR NEXT MESSAGE         64MODE
         SPACE 5
TLBL_DONE DS   0H
         MVC   QXT4STP,QXT4NXT         SET STEP TO NEXT STEP
         LA    R14,TLBL_DLAY           LOAD CRETC DELAY
         CRETC S,QXTI,STATE=1052,PARM=QXT4ACTW
*                                      SET ALARM CLOCK TO WAKE BACK UP
         J     QXTIEXIT                DONE - QUIT UNTIL LATER          64MODE
         EJECT 1
SETUPDONE DS  0H
         PUSH  USING
         GLOBZ REGR=R3                 GET ACCESS TO GLOBALS
         LGF   R3,@ISSDRV              LOAD OUR PIECE OF THEM           64MODE
         LTGR  R3,R3                   GLOBAL AREA AVAILABLE?           64MODE
         JZ    QXTIDONE                NO, BYPASS SETTINGS              64MODE
         SD0RV REG=R3                  R3 = BASE FOR TAPE GLOBALS
         NI    @TD1STAT,X'FF'-@TD1SETU SHOW SETUP NOT RUNNING
         POP   USING
QXTIDONE DS  0H
         LA    R2,QXTIM91              SEND COMPLETION MSG
         BRAS  R7,QXTIWTP1             SEND INFORMATIVE MSG TO USER     64MODE
         J     QXTIEXIT                                                 64MODE
         EJECT 1
QXTISNDM DS 0H
**
*** ADD EOM CHARACTER AND ADJUST THE FINAL MESSAGE LENGTH
**
         LGH   R15,MI0CCT              GET MESSAGE LENGTH               64MODE
         LA    R14,#EOM
         STC   R14,MI0ACC(R15)         PUT EOM CHARACTER IN MSG
*
         LA    R15,L'MI0ADR+L'#EOM(R15)     ADJUST MESSAGE LENGTH
         STH   R15,MI0CCT                   AND UPDATE
**
*** SEND OUT THE MESSAGE
**
         DEFRC ,                       PAUSE BETWEEN MESSAGES
         SGR   R14,R14                 NO PARAMETERS TO PASS            64MODE
         CREEC CVAA,D0,R               SEND THE MESSAGE
         BR    R7                      RETURN TO CALLER
         EJECT 1
QXTIGETM DS    0H                      SETUP AND INITIALIZE MSG BLOCK
         CRUSA S0=0                    GET RID OF DATA LEVEL 0
         GETCC D0,L4                   GET A BLOCK TO BUILD MSG INFO
         LLGF  R6,CE1CR0                                                64MODE
         MVC   MI0BID,=C'MI'           INITIALIZE MSG BLOCK - REC ID
         XC    MI0CHK,MI0CHK           CLEAR HEADER AREA
         XC    MI0CTL,MI0CTL           CLEAR
         XC    MI0PGM,MI0PGM                 HEADER
         XC    MI0FCH,MI0FCH                        AREA
         XC    MI0BCH,MI0BCH           CLEAR HEADER AREA
         XC    MI0ADR,MI0ADR           FORCE RESPONSES TO RO
         BR    R7
         EJECT 1
         DROP  R6
QXTIERR1 DS    0H
         SGR   R3,R3                                                    64MODE
         IC    R3,QXT4STP              INCLUDE VALUE IN MSG
         LA    R2,QXTIM05A
         BRAS  R7,QXTIWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTIEXIT                AND EXIT                         64MODE
         SPACE 5
QXTIERR2 DS    0H
         LA    R3,TBLNAME              INCLUDE VALUE IN MSG
         LA    R2,QXTIM05B
         BRAS  R7,QXTIWTP2             SEND OUT MESSAGE                 64MODE
         J     QXTIEXIT                AND EXIT                         64MODE
         SPACE
QXTIERR3 DS    0H
         LA    R2,QXTIM28
         BRAS  R7,QXTIWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTIEXIT                AND EXIT                         64MODE
         SPACE
QXTIERR4 DS    0H
         LA    R2,QXTIM29
         BRAS  R7,QXTIWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTIEXIT                AND EXIT                         64MODE
QXTIERR5 DS    0H
         LA    R2,QXTIM32
         BRAS  R7,QXTIWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTIEXIT                AND EXIT                         64MODE
QXTIEXIT DS    0H
         EXITC
         DROP  R1
         EJECT
**********************************************************************
* SUBROUTINE: QXTIWTP
*
*           SKELETON WTOPC MACROS
**********************************************************************
         SPACE
         DCTMSG
         USING DCTMSG,R2
QXTIWTP1 DS    0H
         WTOPC PREFIX=TAPE,HEADER=YES,TIME=NO,CHAIN=YES,ENDOFM=YES,    X
               DOT=NO,                                                 X
               NUMA=MSGNUM,                                            X
               LETA=MSGLET,                                            X
               TEXTA=MSGLEN,                                           X
               COMP=YES,                                               X
               EBROUT=YES,                                             X
               ROUT=(TAPE),                                            X
               SUB=(DEC,(R3),DEC,LASTSTEP),                            X
               MF=(E,WTOPCXXX)         AVOID USE OF EBW000-003
         BR    R7
         SPACE 5
QXTIWTP2 DS    0H
         WTOPC PREFIX=TAPE,HEADER=YES,TIME=NO,CHAIN=YES,ENDOFM=YES,    X
               DOT=NO,                                                 X
               NUMA=MSGNUM,                                            X
               LETA=MSGLET,                                            X
               TEXTA=MSGLEN,                                           X
               COMP=YES,                                               X
               EBROUT=YES,                                             X
               ROUT=(TAPE),                                            X
               SUB=(CHARA,(R3)),                                       X
               MF=(E,WTOPCXXX)         AVOID USE OF EBW000-003
         BR    R7
         DROP  R2
         EJECT
**********************************************************************
* MESSAGE TEXT
**********************************************************************
         SPACE
QXTIM05A GENMSG NUM=05,LET=E,                                          X
               TEXT='Internal error - invalid STEP indicator ..'
QXTIM05B GENMSG NUM=05,LET=E,                                          X
               TEXT='Internal error - inconsistent definition of ... taX
               pe'
QXTIM28  GENMSG NUM=28,LET=E,                                          X
               TEXT='System must be no higher than 1052 state to executX
               e this command'
QXTIM29  GENMSG NUM=29,LET=E,                                          X
               TEXT='SETUP command already running'
QXTIM32  GENMSG NUM=32,LET=E,                                          X
               TEXT='Please dismount all tapes in this SSU and reissue X
               command'
QXTIM89  GENMSG NUM=89,LET=I,                                          X
               TEXT='YInitialization step .. of .. started-'
QXTIM90  GENMSG NUM=90,LET=I,                                          X
               TEXT='Please allow .. seconds for this step to complete'
QXTIM91  GENMSG NUM=91,LET=I,                                          X
               TEXT='YTAPE SETUP processing completed-'
         EJECT 1
*----------------------------------------------------------------------
*   TABLE USED IN DEFINING THE PARAMETERS TO BE USED IN DEFINING EACH
*   TAPE NAME.
*
*   FORMAT IS:  TAPE NAME, INDICATOR BYTE, OTHER PARMS
*----------------------------------------------------------------------
         DS    0F
TAPELIST DC    C'RTA',AL1(BSSONLY+IOOUTPUT+BLKMODE),A(MDT10-QXTI0000)
*
         DC    C'RTU',AL1(BSSONLY+IOOUTPUT),A(0)
         DC    C'RTL',AL1(BSSONLY+IOOUTPUT+BLKMODE),A(0)      @F6859RH
         DC    C'RTC',AL1(BSSONLY+IOOUTPUT),A(0)              @TD00452
         DC    C'XAU',AL1(IOINPUT+NOGEN),A(MRTUTAPE-QXTI0000) @TEDMLIN
         DC    C'XBU',AL1(IOINPUT+NOGEN),A(MRTUTAPE-QXTI0000) @TEDMLIN
         DC    C'XCU',AL1(IOINPUT+NOGEN),A(MRTUTAPE-QXTI0000) @TEDMLIN
         DC    C'XDU',AL1(IOINPUT+NOGEN),A(MRTUTAPE-QXTI0000) @TEDMLIN
         DC    C'SDF',AL1(IOINPUT+LNL),A(0)
         DC    C'SCK',AL1(IOINPUT+LNL),A(0)
         DC    C'SNA',AL1(IOINPUT+LNL),A(0)
         DC    C'PLM',AL1(IOBOTH),A(0)
         DC    C'TLD',AL1(IOINPUT+NOGEN),A(0)                 @VS00492
         DC    C'OLD',AL1(IOINPUT+NOGEN),A(0)                 @TD00425
         DC    C'CLD',AL1(BSSONLY+IOINPUT),A(0)
         DC    C'DBF',AL1(IOBOTH),A(0)
         DC    C'DBP',AL1(IOBOTH),A(0)
         DC    C'DBR',AL1(IOBOTH),A(0)                        @TD00402
         DC    C'TUT',AL1(IOINPUT+LNL),A(0)                   @TD00402
         DC    C'BXA',AL1(IOBOTH),A(0)
         DC    C'KPC',AL1(IOBOTH),A(0)
         DC    C'BKD',AL1(IOBOTH),A(0)
         DC    C'RCI',AL1(IOBOTH),A(0)
         DC    C'RCP',AL1(IOBOTH+BLKMODE),A(0)
         DC    C'RPE',AL1(IOBOTH),A(0)
         DC    C'ADR',AL1(IOBOTH),A(0)
         DC    C'BFA',AL1(IOBOTH+NOGEN),A(0)
         DC    C'LOG',AL1(IOBOTH),A(0)                        @TD00453
         DC    C'LRS',AL1(IOBOTH),A(0)                        @TD00453
         DC    C'TST',AL1(IOBOTH+NOGEN),A(0)
         SPACE 5
** TEST MODE LABELS - SPECIAL CASE HANDLING BY TAPE RESTART
         DC    C'GTA',AL1(IOBOTH),A(0)
         DC    C'GTB',AL1(IOBOTH),A(0)
         DC    C'GTC',AL1(IOBOTH),A(0)
         DC    C'GTE',AL1(IOBOTH),A(0)
         SPACE 5
** TAPE DRIVER LABELS
         DC    C'GEN',AL1(IOBOTH+BLKMODE+LSU),A(0)
*                                                             @TD00427
         DC    C'ZA1',AL1(IOBOTH+BLKMODE),A(0)                @TD00427
         DC    C'ZA2',AL1(IOBOTH+BLKMODE),A(0)                @TD00427
         DC    C'ZA3',AL1(IOBOTH),A(0)                        @TD00427
         DC    C'ZA4',AL1(IOBOTH),A(0)                        @TD00427
         DC    C'ZA5',AL1(IOBOTH),A(0)
*
         DC    C'ZB1',AL1(IOBOTH+BLKMODE),A(0)
         DC    C'ZB2',AL1(IOBOTH+BLKMODE),A(0)
         DC    C'ZB3',AL1(IOBOTH),A(0)
         DC    C'ZB4',AL1(IOBOTH),A(0)
         DC    C'ZB5',AL1(IOBOTH),A(0)
*
         DC    C'ZC1',AL1(IOBOTH+BLKMODE),A(0)
         DC    C'ZC2',AL1(IOBOTH+BLKMODE),A(0)
         DC    C'ZC3',AL1(IOBOTH),A(0)
         DC    C'ZC4',AL1(IOBOTH),A(0)
         DC    C'ZC5',AL1(IOBOTH),A(0)
         SPACE 5
** OTHER DRIVER TAPE LABELS                                     TD00383
         DC    C'FAC',AL1(IOBOTH),A(0)                          TD00383
         DC    C'JOB',AL1(IOBOTH+NOGEN),A(0)
*
         DC    C'XXX'                  END OF THE LIST
         EJECT 1
*----------------------------------------------------------------------
*   SKELETON CHARACTER STRINGS FOR USE IN INITIALIZING THE TAPE
*   LABEL TABLE
*----------------------------------------------------------------------
LPARM    EQU   12                      LENGTH OF OPTIONAL PARAMETERS
*
MZTLMR   DC    C'ZTLMR'                TAPE LABEL RECORD COMMAND
MDEACREC DC    C' DEACT'               DEACTIVATE RECORD COMMAND
MINITIAL DC    C' INIT'                INITIALIZE RECORD COMMAND
MZTLBL   DC    C'ZTLBL '               TAPE LABEL COMMAND
MDELTAP  DC    C' DEL'                 DELETE TAPE LABEL
MADDTAP  DC    C' CREATE'              ADD TAPE LABEL
MUSETAP  DC    C' USABLE'              USE TAPE LABEL
*
MINPUT   DC    C' I'                   SPECIFY INPUT MODE TAPE
MOUTPUT  DC    C' O'                   SPECIFY OUTPUT MODE TAPE
MIOBOTH  DC    C' B'                   SPECIFY BOTH IN/OUTPUT TAPE
MLSU     DC    C' LSU'                 SPECIFY STANDARD USER LABELED
MLNL     DC    C' LNL'                 SPECIFY NO LABELED TAPE
MBLOCK   DC    C' BLK'                 SPECIFY BLOCK MODE
MNOGEN   DC    C' G'                   SPECIFY NO GEN NUMBERS @TD00425
*
MD38T0   DC    CL(LPARM)' D38K T0'
MD38T10  DC    CL(LPARM)' D38K T010'
MD38K2T0 DC    CL(LPARM)' D38K2 T0'
MD38K2T10 DC   CL(LPARM)' D38K2 T010'
MDT10    DC    CL(LPARM)' T010'                               @TD00621
MRTUTAPE DC    CL(LPARM)' F$RTU.TAPE$'                        @TEDMLIN
*
SSUBSS   DC    AL2(CPBSSID)            SSU ID FOR BSS
*
TLMR_DLAY EQU  10                      ZTLMR COMMAND DELAY
TLBL_DLAY EQU  30                      ZTLBL COMMAND DELAY
*
STEPDEAC EQU   1
STEPINIT EQU   2
STEPDELT EQU   3
STEPADDT EQU   4
STEPUSET EQU   5
STEPDONE EQU   6
LASTSTEP EQU   STEPUSET
*
ZERO     DC    F'0'
         LTORG
         PRINT GEN
         TA0EQ GLOB=YES
         PRINT NOGEN
         FINIS QXTI
         END
