         PRINT NOGEN
         BEGIN NAME=QXTJ,AMODE=64
***********************************************************************
*       Licensed Materials - Property of IBM                          *
*       "Restricted Materials of IBM"                                 *
*       5748-T15                                                      * 
*       Copyright IBM Corp. 2003, 2006                                *
*       All Rights Reserved                                           *
*       US Government Users Restricted Rights - Use, duplication      *
*       or dislosure restricted by GSA ADP Schedule Contract          *
*       with IBM Corp.                                                *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
***********************************************************************
*
* MODULE NAME..... QXTJ
* DESCRIPTION..... GENERAL TAPE DRIVER
* RELATED MODULE.. QXTG
*                  QXTH
*                  QXTK
*
* DOCUMENT NAME... GENERAL TAPE DRIVER USERS GUIDE
* LEVEL........... N/A
*
* FUNCTION...      THIS SEGMENT DRIVES THE SYSTEM TEST INTERFACE
*                  TO THE TAPE DRIVER
*
* MODULE ATTRIBUTES..
*   TYPE.......... 'E' (ECB CONTROLLED)
*   DEPENDENCY.... NONE (OBJECT SHIPPABLE)
*   ALLOCATION.... 4K FILE RESIDENT
*   ENVIRONMENT... BASE, BSS
*   ENTRY POINT... QXTJ  (ENTNC FROM QTP1)
*
* ECB-CONVENTIONS.......
*
*   WORK AREA
*    EBX000-103      SEE EQUATE MACRO TA0EQ
*    EBW000-103      SEE EQUATE MACRO TA0EQ
*
* DATA LEVELS
*         D0 - MESSAGE LEVEL -- USED TO CREATE AN OUTPUT MESSAGE
*              THAT WILL BE FORWARDED TO THE INPUT MESSAGE PROCESSOR
*
* REGISTER-CONVENTIONS..
*
*         R0 -
*         R1 -  GLOBALS BASE REGISTER
*         R2 -
*         R3 -  BASE REGISTER OF THE STAGE TABLE
*         R4 -  BAS REGISTER FOR STOP$CHK ROUTINE
*         R5 -  BCT REG  - 'STOP ALL' AND 'STOP$CHK' ROUTINES
*         R6 -  WTOPC USAGE - POINTER TO MESSAGE TEXT DSECT
*            -  PARAMETER LIST POINTER FOR C SEGMENT QTP3
*         R7 -  BAS REGISTER -- ROUTINES QXTJWTPx AND QXTJGLBx
*         R14 - SCRATCH (ALSO TIMEINC PARAMETER TO CRETC)
*         R15 - SCRATCH
*
***********************************************************************
** CHANGE ACTIVITY...
**
**        UPDATE BY      PLOG #   DATE   DESCRIPTION
**        ---------      -------  ------ ------------
**        KENT           TD00301  071390 MSG SETTING ENHANCEMENTS
**        KENT           TD00346  022891 TEP PROJECT IMPROVEMENTS
**        KENT           TD00392  120491 FIX 'NORTA' SUPPORT
**        YMLI           F14612   081506 The output routing
**        YMLI           D14945   112706 'ZTEST TA64 START tape_label'
**                                     should exercise TA64 test cases
***********************************************************************
         EJECT 1
         MACRO
&LABEL   DEFSTAGE                                                      X
               &COMMAND,                                               X
               &NEXT=,                                                 X
               &OPT1=0,                                                X
               &OPT2=0
         AIF   ('&NEXT' EQ '').SEQNEXT NEXT STEP IS SEQUENTIAL
&LABEL   DC    AL1(&NEXT)              SPECIFIC NEXT STAGE
         AGO   .CONTINU                CONTINUE
.SEQNEXT ANOP  ,
&LABEL   DC    AL1(*-STGTABLE+LSTG$TBL) SEQUENTIAL NEXT STAGE
.CONTINU ANOP  ,
         DC    AL1(&COMMAND)           COMMAND OPCODE
         DC    AL1(&OPT1)              OPTIONAL VALUE 1
         DC    AL1(&OPT2)              OPTIONAL VALUE 2
         MEND
         SPACE 2
*
         EJECT 1
*
         J     QXTJ0000                BRANCH AROUND EYE-CATCHER        64MODE
         DC    CL8'&SYSDATE',CL1' ',CL8'&SYSTIME'
         SPACE 2
QXTJGLB1 DS    0H                      SET UP TO USE TAPE GLOBAL 1
         GLOBZ REGR=R1
         LLGF  R1,@ISSDRV                                               64MODE
         SD0RV REG=R1                  BASE FOR OUR USAGE OF GLOBALS
         BR    R7                      RETURN TO CALLER
         SPACE 5
QXTJGLB2 DS    0H                      SET UP TO USE TAPE GLOBAL 2
         GLOBZ REGR=R1
         LLGF  R1,@ISSDRV                                               64MODE
         SD0RV REG=R1                  BASE FOR OUR USAGE OF GLOBALS
         SPACE 2
         SGR   R15,R15                                                  64MODE
         IC    R15,TAPEGLOB            PICK UP GLOBAL INDEX VALUE
         MGHI  R15,L'@TD2FLD           CALCULATE ACTUAL INDEX           64MODE
         LA    R1,0(R15,R1)            ADJUST ADDRESS
         SPACE 2
         BR    R7                      RETURN TO CALLER
         SPACE 2
QXTJ0000 DS    0H
*
         LEVTA LEVEL=0,INUSE=QXTJUCMD  BLOCK HELD ON LEVEL 0?
*
* IF SO, PROCESS USER COMMAND
*
         SPACE 5
*
* OTHERWISE, WE'VE JUST WOKE UP FROM CRETC - INITIALIZE NECESSARY
* FIELDS
*
         XC    TAPEINDC,TAPEINDC       INITIALIZE ECB WORK AREA
         SPACE
         CINFC R,CMMXCR                GET PRIME CRAS ADDRESS
         MVC   EBROUT,0(R14)           INITIALIZE EBROUT FOR STEPS
         MVC   TAPEGLOB,QXT5TAPN       MAKE SURE INDEX MATCHES OURS
         SPACE
         BRAS  R7,QXTJGLB1             GET ACCESS TO GLOBAL AREA        64MODE
*
         TM    @TD1STAT,@TD1ACTV       DRIVER STILL ACTIVE?
         JZ    QXTJERR6                NO, EXIT THIS ECB                64MODE
*
         TM    @TD1STAT,@TD1STOP       DRIVER STOP IN PROGRESS?
         JZ    QXTJ0010                NO, CONTINUE ON                  64MODE
         BRAS  R4,STOP$CHK             CHECK TO SEE IF ALL STOPPED      64MODE
QXTJ0010 DS    0H
*
         BRAS  R7,QXTJGLB1             GET ACCESS TO GLOBAL AREA        64MODE
         TM    @TD1STAT,@TD1PAUZ       DRIVER PAUSED?
         JO    QXTJ0020                YES, WAIT UNTIL RESTARTED        64MODE
*
         J     QXTJC000                BRANCH TO MSG ROUTINE            64MODE
         SPACE 2
QXTJ0020 DS    0H
*
*  CRET AGAIN AND WAIT
*
         LA    R14,PAUZTIME
         CRETC S,QXTJ,STATE=1052,PARM=QXT5ACTW
         J     QXTJEXIT                                                 64MODE
         EJECT 1
QXTJUCMD DS    0H                      DETERMINE USER COMMAND
         BRAS  R7,QXTJGLB1             ESTABLISH TAPE GLOBAL 1 BASE     64MODE
         CLI   ACTCMD,STARTCMD         USER SAYS START?
         JE    QXTJSTRT                START THE SYSTEST DRIVER         64MODE
         CLI   ACTCMD,STOPCMD          USER SAYS STOP?
         JE    QXTJSTOP                STOP INDICATED TAPE(S)           64MODE
         J     QXTJERR1                I DON'T KNOW WHAT THEY WANT      64MODE
         EJECT 1
STOP$CHK DS    0H                      CHECK IF ALL TAPES ARE STOPPED
         IC    R0,TAPEGLOB             SAVE GLOBAL INDEX
         XC    TAPEGLOB,TAPEGLOB       START OUT WITH BASE INDEX
         BRAS  R7,QXTJGLB2                                              64MODE
         STC   R0,TAPEGLOB             RESTORE GLOBAL INDEX
         LA    R5,SD0MAXTAPE           COUNT OF ENTRIES TO CHECK
STOPCHK1 DS    0H
         TM    @TD2STAT,@TD2ACTV       IS THIS TAPE ACTIVE?
         BOR   R4                      TAPE(S) STILL ACTIVE - RETURN
         LA    R1,L'@TD2FLD(R1)        BUMP BASE REG TO NEXT ENTRY
         BRCTG R5,STOPCHK1             OTHERWISE, CONTINUE CHECKING     64MODE
*
*  NO ACTIVE TAPES FOUND - SEND OUT MESSAGE THAT DRIVER IS STOPPED
*
         J     QXTJEXM1                SEND OUT EXIT MESSAGE 1          64MODE
         EJECT 1
QXTJSTRT DS    0H                      START THE INDICATED TAPE
         TM    @TD1STAT,@TD1PAUZ       DRIVER PAUSED?
         JO    QXTJERR2                YES, SEND ERROR MESSAGE          64MODE
         SPACE 2
*
*  CHECK TO SEE IF THIS TAPE ALREADY STARTED
*
         SPACE 2
STRT$100 DS    0H
         MVI   TAPEFUNC,FUNC@EGE       TRY TO ADD TAPE INTO GLOBAL
         ENTRC QXTK                    CALL SEGMENT TO DO IT
         SPACE 2
         CGHI  R5,GLOBDUPL             WAS THE TAPE ALREADY THERE?      64MODE
         JE    QXTJERR3                YES, SEND ERROR MESSAGE          64MODE
         LTGR  R5,R5                   RETURN CODE 0?                   64MODE
         JNZ   QXTJX000                NO, ANALYZE RETURN CODE          64MODE
         SPACE 2
         BRAS  R7,QXTJGLB2             ADDRESS THE TAPE NAME ENTRY      64MODE
         TM    @TD2STAT,@TD2ACTV       IS THIS TAPE ALREADY ACTIVE?
         JO    QXTJERR3                YES, SEND ERROR MESSAGE          64MODE
         SPACE 2
*
*  SET BASE OF STAGE TABLE
*
         USING STG$LIST,R3
         LA    R14,PRELIM              CALC ADDR OF PRELIM STATE
         LA    R3,STGTABLE(R14)        ADDRESS THE STAGE STATE TABLE
*
*  START UP THIS TAPE FOR INITIAL STAGE
*
*
         PUSH  USING
         GLMOD ,                       SET PROTECT KEY FOR MODIFY
         GLOBZ REGR=R14
         OI    @SWITCH+1,TAPELTHL      SET TAPE @SWITCH BIT
         FILKW R                       RESTORE PROTECT KEY
         POP   USING
*
         BRAS  R7,QXTJGLB1             TEMPORARILY ACCESS AREA 1        64MODE
*
         TM    @TD1STAT,@TD1ACTV       SET ACTIVE BIT ON YET?
         JO    STRT$200                YES, SKIP SETTING OTHERS         64MODE
         OI    @TD1STAT,@TD1ACTV       INDICATE DRIVER STARTED
         OI    @TD1STAT,@TD1WRTA       INDICATE WRITE TO RTA
         MVI   @TD1CRTT,STATEDLY       STORE CRET TIME IN GLOBAL
         MVI   @TD1MSGS,MSGEMSG        STORE MSG CONTROL IN GLOBAL
         MVC   @TD1MINC,=H'1000'       STORE DEFAULT MINCOUNT VALUE
         MVC   @TD1MAXC,=H'25000'      STORE DEFAULT MAXCOUNT VALUE
         SPACE 2
STRT$200 DS    0H
         SGR   R14,R14                                                  64MODE
         IC    R14,@TD1CRTT            GET CRETC TIME FROM GLOBAL
*
         BRAS  R7,QXTJGLB2             RESTORE ACCESS TO AREA 2         64MODE
*
         XC    @TD2STAT,@TD2STAT       CLEAR OUT FIELDS
         XC    @TD2STCS,@TD2STCS         ...
         XC    @TD2FTCS,@TD2FTCS         ...
         XC    @TD2FTCC,@TD2FTCC         ...
         XC    @TD2ITER,@TD2ITER         ...
         XC    @TD2ECNT,@TD2ECNT         ...
         XC    @TD2CMDS,@TD2CMDS       CLEAR OUT FIELDS
*
         OI    @TD2STAT,@TD2ACTV       TURN ON INDICATOR FOR TAPE
         MVI   QXT5ISTG,PRELIM         SET PRELIMINARY STAGE
         MVC   QXT5TAPN,TAPEGLOB       MOVE TAPE INDEX INTO CRET FIELD
*
*  ISSUE CRET TO WAKE US UP LATER
*
         CRETC S,QXTJ,STATE=1052,PARM=QXT5ACTW
*
*  SEND OUT MESSAGE TO USER ACKNOWLEDGING TAPE START
*
         SPACE 2
STRT$300 DS    0H
         LA    R6,QXTJM84              SEND OUT MESSAGE 84
         BRAS  R7,QXTJWTP1                                              64MODE
         J     QXTJEXIT                                                 64MODE
         EJECT 1
QXTJSTOP DS    0H                      STOP THE INDICATED TAPE
         CLI   STOPOPT,STOPBP          STOP WITH BYPASS SPECIFIED?
         JE    STOP$100                YES, SKIP NEXT CHECK             64MODE
         SPACE
         TM    @TD1STAT,@TD1ACTV       IS DRIVER ACTIVE?
         JZ    QXTJERR4                NO, SEND ERROR MESSAGE           64MODE
STOP$100 DS    0H                      STOP THE INDICATED TAPE
         CLC   CHARALL,CHARTAPE        STOP ALL TAPES?
         JE    STOP$200                THEN STOP ALL TAPES              64MODE
         J     STOP$300                OTHERWISE STOP SINGLE TAPE       64MODE
         SPACE 5
*
*  STOP ALL TAPES BY MARKING ACTIVE TAPES WITH 'STOP' MODE
*
*  -- IF THE 'BP' OPTION WAS SPECIFIED, JUST CLEAR OUT THE
*  -- INDICATOR ENTIRELY.
*
STOP$200 DS    0H
         OI    @TD1STAT,@TD1STOP       SET 'DRIVER STOP IN PROGRESS'
         NI    @TD1STAT,X'FF'-@TD1WRTA TURN OFF 'WRITE TO RTA'
         CLI   STOPOPT,STOPBP          STOP WITH BYPASS?
         JNE   STOP$210                NO, CONTINUE NORMALLY            64MODE
         XC    @TD1FLD,@TD1FLD         FORCIBLY CLEAR ALL INDICATORS
STOP$210 DS    0H
         XC    TAPEGLOB,TAPEGLOB       START OUT WITH BASE INDEX
         BRAS  R7,QXTJGLB2             ADDRESS INDICATED ENTRY          64MODE
         SPACE
         LA    R5,SD0MAXTAPE           COUNT OF ENTRIES TO CHECK
STOP$220 DS    0H
         TM    @TD2STAT,@TD2ACTV       IS THIS TAPE ACTIVE?
         JZ    STOP$230                NO, ITERATE TO NEXT ENTRY        64MODE
         OI    @TD2STAT,@TD2STOP       SET 'TAPE STOP IN PROGRESS'
*
*  FOR ALL ACTIVE TAPES, SEND OUT MSG THAT THE TAPE IS STOPPING
*
         MVC   CHARTAPE,@TD2TAPE       MOVE IN TAPE NAME FOR MESSAGE
         LA    R6,QXTJM85              SEND OUT MESSAGE 85
         BRAS  R7,QXTJWTP1                                              64MODE
*
         CLI   STOPOPT,STOPBP          STOP WITH BYPASS?
         JNE   STOP$230                NO, CONTINUE NORMALLY            64MODE
*
         LA    R6,QXTJM86              SEND OUT MESSAGE 86
         BRAS  R7,QXTJWTP1             TELL USER TAPE STOPPED           64MODE
         XC    @TD2FLD,@TD2FLD         FORCIBLY CLEAR INDICATORS
STOP$230 DS    0H
         LA    R1,L'@TD2FLD(R1)        BUMP BASE REG TO NEXT ENTRY
         BRCTG R5,STOP$220             AND ITERATE                      64MODE
*
         LA    R6,QXTJM87              SEND OUT MESSAGE 87
         BRAS  R7,QXTJWTP1             TELL USER DRIVER STOPPING        64MODE
*
         CLI   STOPOPT,STOPBP          STOP WITH BYPASS?
         JNE   QXTJEXIT                NO, JUST EXIT                    64MODE
         BRAS  R4,STOP$CHK             YES, CLEAN UP AND SEND MESSAGE   64MODE
         J     QXTJEXIT                THEN EXIT                        64MODE
         SPACE 5
*
*  STOP A SINGLE INDICATED TAPE BY MARKING THE APPROPRIATE
*  INDICATORS.
*
*  -- IF THE 'BP' OPTION WAS SPECIFIED, JUST CLEAR OUT THE
*  -- INDICATOR ENTIRELY.
*
STOP$300 DS    0H
         MVI   TAPEFUNC,FUNC@LOC       LOCATE TAPE ENTRY IN GLOBAL
         ENTRC QXTK                    CALL SEGMENT TO DO IT
         SPACE 2
         CGHI  R5,GLOBNFND             TAPE NOT FOUND IN GLOBAL?        64MODE
         JE    QXTJERR5                SEND OUT ERROR MESSAGE           64MODE
         LTGR  R5,R5                   RETURN CODE 0?                   64MODE
         JNZ   QXTJX000                NO, ANALYZE RETURN CODE          64MODE
         SPACE 2
         BRAS  R7,QXTJGLB2             ADDRESS TAPE GLOBAL 2            64MODE
         SPACE 2
         CLI   STOPOPT,STOPBP          STOP WITH BYPASS?
         JNE   STOP$310                NO, CONTINUE NORMALLY            64MODE
         XC    @TD2FLD,@TD2FLD         FORCIBLY CLEAR INDICATORS
         J     STOP$320                CONTINUE PROCESSING              64MODE
         SPACE 2
STOP$310 DS    0H
         TM    @TD2STAT,@TD2ACTV       IS TAPE STARTED?
         JZ    QXTJERR5                NO, SEND OUT ERROR MESSAGE       64MODE
         OI    @TD2STAT,@TD2STOP       SET 'TAPE STOP IN PROGRESS'
         SPACE 2
STOP$320 DS    0H
**
**  SEND OUT MESSAGE TO USER ACKNOWLEDGING TAPE STOP
**
         LA    R6,QXTJM85              SEND OUT MESSAGE 85
         BRAS  R7,QXTJWTP1                                              64MODE
         CLI   STOPOPT,STOPBP          STOP WITH BYPASS?
         JNE   QXTJEXIT                NO, JUST EXIT OTHERWISE EXIT     64MODE
*
         LA    R6,QXTJM86              LOAD ADDRESS OF MESSAGE TEXT
         BRAS  R7,QXTJWTP1             TELL USER TAPE STOPPED           64MODE
*
         BRAS  R4,STOP$CHK             CHECK FOR LAST ACTIVE TAPE       64MODE
         J     QXTJEXIT                AND EXIT                         64MODE
         EJECT 1
QXTJC000 DS    0H
**
*  ISSUE COMMANDS TO DRIVE SYSTEM TEST ACTIVITY
*
**
         BRAS  R7,QXTJGLB2             ESTABLISH TAPE GLOBAL 2 BASE     64MODE
         MVC   CHARTAPE,@TD2TAPE       COPY TAPE NAME FROM GLOBAL
*
         SGR   R15,R15                                                  64MODE
         IC    R15,QXT5ISTG            GET STAGE INDICATOR
         LA    R3,STGTABLE(R15)        ACCESS CORRECT TABLE ENTRY
*
         TM    @TD2STAT,@TD2ACTV       IS TAPE RUNNING?
         JZ    QXTJERR6                NO, INVALID CONDITION            64MODE
**
*  ENSURE LAST COMMAND HAS COMPLETED BEFORE WE DO ANYTHING
**
         CLC   @TD2STCS,ZERO           NO PREVIOUS COMMAND?
         JE    C000$100                YES, DON'T WAIT ON IT            64MODE
*
         CLI   STG$CMD,WRITECMD        USING A REALTIME TAPE?
         JE    C000$050                YES, ADVANCE TO NEXT STEP        64MODE
*
         CLC   @TD2FTCS,@TD2FTCC       FUNCTION TEST CMD COMPLETED?
         JNE   C000$CRT                NO, WAIT FOR IT                  64MODE
*
         CLC   @TD2STCS,@TD2FTCC       COMMAND WE ISSUED COMPLETED?
         JNE   C000$CRT                NO, WAIT FOR IT                  64MODE
*
*  OTHERWISE, THE COMMAND IS COMPLETE, AND WE CAN MOVE
*  ONWARD TO THE NEXT STAGE
*
C000$050 DS    0H
         SPACE 2
         XC    @TD2FTCS,@TD2FTCS       CLEAR OUT FIELDS PRIOR TO CALL
         XC    @TD2FTCC,@TD2FTCC       CLEAR OUT FIELDS PRIOR TO CALL
*
         TM    @TD2STAT,@TD2STOP+@TD2CLOS   STOP THIS TAPE?
         JO    QXTJEXM2                YES, SEND A MESSAGE AND EXIT     64MODE
*
         MVC   QXT5ISTG,STG$NEXT       INDICATE NEXT STEP IN ECB
*
*  UPDATE THE STAGE TABLE POINTER TO REFLECT THE NEW STATE
*
         SGR   R15,R15                                                  64MODE
         IC    R15,QXT5ISTG            GET STAGE INDICATOR
         LA    R3,STGTABLE(R15)        ACCESS CORRECT TABLE ENTRY
         SPACE 2
C000$100 DS    0H
         CLI   STG$CMD,WRITECMD        REALTIME TAPE COMMAND?
         JNE   C000$200                NO, LEAVE TAPE NAME ALONE        64MODE
         SPACE 2
*                                                               TD00392
         BRAS  R7,QXTJGLB1             ACCESS TAPE GLOBAL 1     TD00392 64MODE
         MVC   EBXSW1,@TD1STAT         STORE BYTE TEMPORARILY   TD00392
         BRAS  R7,QXTJGLB2             RESTORE ACCESS TO GLOBAL TD00392 64MODE
*                                                               TD00392
         TM    EBXSW1,@TD1WRTA         WRITE TO RTx TAPES?      TD00392
         JZ    C000$NXT                NO, SKIP THIS STEP       TD00392 64MODE
         SPACE 2                                                TD00392
         CLI   STG$OPT1,TAPERTA        USE THE RTA TAPE?
         JNE   C000$110                NO, CHECK FOR ANOTHER TAPE       64MODE
         MVC   CHARTAPE(L'CHARRTA),CHARRTA  SET TAPE NAME
         J     C000$200                BUILD AND SEND MESSAGE           64MODE
         SPACE 2
C000$110 DS    0H
         CLI   STG$OPT1,TAPERTL        WRITE TO THE RTL TAPE?
         JNE   C000$NXT                NO, ALL OUT OF TAPES - SKIP IT   64MODE
         MVC   CHARTAPE(L'CHARRTL),CHARRTL  SET TAPE NAME
         J     C000$200                BUILD AND SEND MESSAGE           64MODE
         SPACE 2
C000$200 DS    0H                      CALL ROUTINE TO GENERATE COMMAND
         ST    R3,TA0WORK1             STORE ADDRESS OF STAGE ENTRY
         LGR   R6,R1                                           @TD00619 64MODE
         STM   R0,R7,TESTFIX           TEST FIX *****          @TD00619
         LLGF  R2,TA0WORK1             LOAD ADDRESS OF PARAMETER LIST   D7469
         ENTRC QTP3                    GENERATE AND SEND MSG
         LGR   R1,R6                                           @TD00619 64MODE
         LM    R0,R7,TESTFIX           TEST FIX *****          @TD00619
**
*** PREPARE FOR NEXT MESSAGE
**
         MVC   CHARTAPE,@TD2TAPE       RESTORE TAPE NAME FROM GLOBAL
         SPACE 2
C000$NXT DS    0H
         CLI   QXT5ISTG,REPEAT         ARE WE AT THE END OF THE LOOP?
         JNE   C000$CRT                NO, JUST CONTINUE                64MODE
         LGH   R15,@TD2ITER            GET OLD ITERATION VALUE          64MODE
         AGHI  R15,1                   ADD ONE                          64MODE
         STH   R15,@TD2ITER            AND UPDATE GLOBAL VALUE
*
         ST    R15,TA0WORK2            STORE ITERATION COUNT FOR MSG
         LA    R6,QXTJM92              LOAD UP MSG TEXT ADDRESS
         BRAS  R7,QXTJWTP1             SEND OUT MESSAGE                 64MODE
         SPACE 2
C000$CRT DS    0H
         BRAS  R7,QXTJGLB1             ADDRESS TAPE GLOBAL 1            64MODE
         SGR   R14,R14                                                  64MODE
         IC    R14,@TD1CRTT            SET WAKEUP TIME FOR CRETC
         SPACE 2
         CRETC S,QXTJ,STATE=1052,PARM=QXT5ACTW
         J     QXTJEXIT                DONE - QUIT UNTIL LATER          64MODE
         DROP  R3
         EJECT 1
QXTJERR1 DS    0H
         LA    R6,QXTJM05A             LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
         SPACE 5
QXTJERR2 DS    0H
         LA    R6,QXTJM23              LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
         SPACE 5
QXTJERR3 DS    0H
         LA    R6,QXTJM25              LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
         SPACE 5
QXTJERR4 DS    0H
         LA    R6,QXTJM22              LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
         SPACE 5
QXTJERR5 DS    0H
         LA    R6,QXTJM26              LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
QXTJERR6 DS    0H
         LA    R6,QXTJM05B             LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
         EJECT 1
QXTJX000 DS    0H                      ANALYZE QXTK RETURN CODES
         CGHI  R5,GLOBDUPL             ATTEMPT TO ADD DUPLICATE TAPE    64MODE
         JE    QXTJX010                                                 64MODE
         CGHI  R5,GLOBNULL             NO GLOBALS AVAILABLE             64MODE
         JE    QXTJX020                                                 64MODE
         CGHI  R5,GLOBFULL             GLOBAL AREA FULL                 64MODE
         JE    QXTJX030                                                 64MODE
         CGHI  R5,GLOBNFND             TAPE ENTRY NOT FOUND             64MODE
         JE    QXTJX040                                                 64MODE
         J     QXTJX999                UNKNOWN RETURN CODE              64MODE
         SPACE 2
QXTJX010 DS    0H                      ATTEMPT TO ADD DUPLICATE TAPE
         LA    R6,QXTJM33A             LOAD ADDRESS OF ERROR TEXT
         BRAS  R7,QXTJWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTJEXIT                                                 64MODE
         SPACE 2
QXTJX020 DS    0H                      GLOBALS NOT AVAILABLE
         LA    R6,QXTJM33B
         BRAS  R7,QXTJWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTJEXIT                AND EXIT                         64MODE
         SPACE 2
QXTJX030 DS    0H                      GLOBAL AREA FULL
         LA    R6,QXTJM33C
         BRAS  R7,QXTJWTP1             SEND OUT MSG                     64MODE
         J     QXTJEXIT                AND EXIT                         64MODE
         SPACE 2
QXTJX040 DS    0H                      ENTRY NOT FOUND
         LA    R6,QXTJM33D
         BRAS  R7,QXTJWTP1             SEND OUT MSG                     64MODE
         J     QXTJEXIT                AND EXIT                         64MODE
         SPACE 5
QXTJX999 DS    0H                      UNKNOWN RETURN CODE
         ST    R5,TA0WORK2             STORE FOR OUTPUT MSG
         LA    R6,QXTJM33Z
         BRAS  R7,QXTJWTP1             SEND OUT MESSAGE                 64MODE
         J     QXTJEXIT                AND EXIT                         64MODE
         EJECT 1
QXTJEXM1 DS    0H
*
*  UPON ENTRY, GLOBAL AREA POINTER IS INDETERMINATE
*
         BRAS  R7,QXTJGLB1             RESTORE GLOBALS BASE             64MODE
         XC    @TD1FLD,@TD1FLD         CLEAR INDICATORS
*
         GLMOD ,                       SET PROTECT KEY FOR MODIFY
         PUSH  USING
         GLOBZ REGR=R14
         NI    @SWITCH+1,X'FF'-TAPELTHL SET TAPE @SWITCH BIT
         FILKW R                       RESTORE PROTECT KEY
         POP   USING
*
         LA    R6,QXTJM88              LOAD ADDRESS OF MESSAGE TEXT
         BRAS  R7,QXTJWTP1             AND SEND OUT MESSAGE             64MODE
         J     QXTJEXIT                                                 64MODE
         SPACE 5
QXTJEXM2 DS    0H
*
*  UPON ENTRY, GLOBAL AREA POINTS TO CORRECT TAPE ENTRY
*
         SPACE 2
         XC    @TD2FLD,@TD2FLD         CLEAR ALL INDICATORS
         LA    R6,QXTJM86              LOAD ADDRESS OF MESSAGE TEXT
         BRAS  R7,QXTJWTP1             AND TELL USER TAPE STOPPED       64MODE
         SPACE 2
         BRAS  R4,STOP$CHK             ALSO CHECK AND SEE IF THIS WAS   64MODE
*                                      THE LAST TAPE RUNNING.
         J     QXTJEXIT                                                 64MODE
QXTJEXIT DS    0H
         EXITC ,
         DROP  R1
         EJECT 1
*----------------------------------------------------------------------
*   SKELETON WTOPC MACROS
*----------------------------------------------------------------------
         DCTMSG
         USING DCTMSG,R6
QXTJWTP1 DS    0H
         WTOPC PREFIX=TA64,HEADER=YES,TIME=NO,CHAIN=YES,ENDOFM=YES,    X
               DOT=NO,                                                 X
               NUMA=MSGNUM,                                            X
               LETA=MSGLET,                                            X
               TEXTA=MSGLEN,                                           X
               COMP=YES,                                               X
               EBROUT=YES,                                             X
               ROUT=(TAPE),            ROUTE TO PRC IF NOT ALREADY     X
               MF=(E,WTOPCXXX),        AVOID USE OF EBW000-003         X
               SUB=(CHARA,CHARTAPE,DECA,TA0WORK2)                      X
                                       SUBSTITUTION VALUE IN ECB
         BR    R7
         DROP  R6
*----------------------------------------------------------------------
*   MESSAGE DEFINITIONS
*----------------------------------------------------------------------
*  ERROR MESSAGES
QXTJM05A GENMSG LET=E,NUM=05,                                          X
               TEXT='LOGIC ERROR IN ACTION COMMAND CODE'
QXTJM05B GENMSG LET=E,NUM=05,                                          X
               TEXT='DRIVER STOPPED condition detected when not expecteX
               d'
QXTJM22  GENMSG LET=E,NUM=22,                                          X
               TEXT='Command ignored - driver not START''ed'
QXTJM23  GENMSG LET=E,NUM=23,                                          X
               TEXT='Command ignored - driver is PAUSE''d'
QXTJM25  GENMSG LET=E,NUM=25,                                          X
               TEXT='Command ignored - tape ... already started'
QXTJM26  GENMSG LET=E,NUM=26,                                          X
               TEXT='Command ignored - tape ... not START''ed'
QXTJM33A GENMSG LET=E,NUM=33,                                          X
               TEXT='QXTK attempted to add duplicate tape name'
QXTJM33B GENMSG LET=E,NUM=33,                                          X
               TEXT='QXTK couldn''t get the globals address'
QXTJM33C GENMSG LET=E,NUM=33,                                          X
               TEXT='No tape entries available - too many active tapes'
QXTJM33D GENMSG LET=E,NUM=33,                                          X
               TEXT='Tape entry ... not found in global table'
QXTJM33Z GENMSG LET=E,NUM=33,                                          X
               TEXT='Invalid return .... code from QXTK'
*  INFORMATIVE MESSAGES
QXTJM84  GENMSG LET=I,NUM=84,                                          X
               TEXT='Tape ... START''ing'
QXTJM85  GENMSG LET=I,NUM=85,                                          X
               TEXT='Tape ... STOP''ing'
QXTJM86  GENMSG LET=I,NUM=86,                                          X
               TEXT='Tape ... STOP''ed'
QXTJM87  GENMSG LET=I,NUM=87,                                          X
               TEXT='Tape driver STOP''ing'
QXTJM88  GENMSG LET=I,NUM=88,                                          X
               TEXT='Tape driver STOP''ed'
QXTJM92  GENMSG LET=I,NUM=92,                                          X
               TEXT='Tape ... has completed iteration ........'
*----------------------------------------------------------------------
*   DEFINITION OF THE FLOW BETWEEN "STAGES" OF DRIVER ACTIVITY
*----------------------------------------------------------------------
*
PAUZTIME EQU   30                 WHEN PAUSED, DELAY TIME
STATEDLY EQU   20                 INITIAL DELAY BETWEEN STAGES
*
STGTABLE DS    0F
STGPRLM  DEFSTAGE REWCMD,NEXT=HOME
STGHOME  DEFSTAGE OUTPTCMD,OPT1=L0,OPT2=CYCLENO
         DEFSTAGE SYNCCMD
         DEFSTAGE REWCMD
         DEFSTAGE INPUTCMD,OPT1=L0
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L0,OPT2=CYCLENO
*
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L0,OPT2=CYCLEYES
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L0,OPT2=CYCLEYES
*
         DEFSTAGE WRITECMD,OPT1=TAPERTA,OPT2=CYCLENO
         DEFSTAGE WRITECMD,OPT1=TAPERTA,OPT2=CYCLEYES
*
         DEFSTAGE REWCMD
         DEFSTAGE CCWCMD,OPT1=OPCWRT,OPT2=CYCLENO
         DEFSTAGE REWCMD
         DEFSTAGE CCWCMD,OPT1=OPCRDF,OPT2=CYCLENO
*
         DEFSTAGE WRITECMD,OPT1=TAPERTL,OPT2=CYCLENO
         DEFSTAGE WRITECMD,OPT1=TAPERTL,OPT2=CYCLEYES
*
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L1,OPT2=CYCLENO
         DEFSTAGE REWCMD
         DEFSTAGE SYNCCMD
         DEFSTAGE INPUTCMD,OPT1=L1
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L1,OPT2=CYCLENO
*
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L1,OPT2=CYCLEYES
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L1,OPT2=CYCLEYES
*
         DEFSTAGE WRITECMD,OPT1=TAPERTA,OPT2=CYCLENO
         DEFSTAGE WRITECMD,OPT1=TAPERTA,OPT2=CYCLEYES
*
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L2,OPT2=CYCLENO
         DEFSTAGE REWCMD
         DEFSTAGE INPUTCMD,OPT1=L2
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L2,OPT2=CYCLENO
*
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L2,OPT2=CYCLEYES
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L2,OPT2=CYCLEYES
*
         DEFSTAGE WRITECMD,OPT1=TAPERTL,OPT2=CYCLENO
         DEFSTAGE WRITECMD,OPT1=TAPERTL,OPT2=CYCLEYES
*
         DEFSTAGE REWCMD
         DEFSTAGE CCWCMD,OPT1=OPCWRT,OPT2=CYCLENO
         DEFSTAGE REWCMD
         DEFSTAGE CCWCMD,OPT1=OPCRDF,OPT2=CYCLENO
*
         DEFSTAGE WRITECMD,OPT1=TAPERTA,OPT2=CYCLENO
         DEFSTAGE WRITECMD,OPT1=TAPERTA,OPT2=CYCLEYES
*
         DEFSTAGE REWCMD
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L4,OPT2=CYCLENO
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L4,OPT2=CYCLENO
         DEFSTAGE REWCMD
*
         DEFSTAGE REWCMD
         DEFSTAGE OUTPTCMD,OPT1=L4,OPT2=CYCLEYES
         DEFSTAGE REWCMD
         DEFSTAGE VERFYCMD,OPT1=L4,OPT2=CYCLEYES
         DEFSTAGE REWCMD
*
         DEFSTAGE WRITECMD,OPT1=TAPERTL,OPT2=CYCLENO
STGREPT  DEFSTAGE WRITECMD,OPT1=TAPERTL,OPT2=CYCLEYES,NEXT=HOME
         SPACE 2
PRELIM   EQU   STGPRLM-STGTABLE
HOME     EQU   STGHOME-STGTABLE
REPEAT   EQU   STGREPT-STGTABLE
         SPACE 2
ZERO     DC    F'0'               ZERO FOR COMPARISONS
*
TAPERTA  EQU   C'A'               INDICATOR FOR TAPE=RTA
TAPERTL  EQU   C'L'               INDICATOR FOR TAPE=RTL
*
CHARRTA  DC    C'RTA'             TEXTUAL TAPE NAMES
CHARRTL  DC    C'RTL'
CHARALL  DC    C'ALL'
*
         PRINT GEN
         TA0EQ GLOB=YES
         PRINT NOGEN
         LTORG
         FINIS QXTJ
         END  ,
